/*
GLSLFlp`̕`i}eAj
*/
#include <fstream>
#include <string>
#include <iostream>
#include <GL/glew.h>
#include <GL/glut.h>
using namespace std;

int WindowPositionX = 200;  //EBhEʒuXW
int WindowPositionY = 100;  //EBhEʒuYW
int WindowWidth  = 512;     //EBhE̕
int WindowHeight = 512;     //EBhE̍
char WindowTitle[] = "E̎n܂";	//EBhẼ^Cg

//----------------------------------------------------
// BITMAPf[^̓ǂݍݗpi\́j
//----------------------------------------------------
#define TEXTURE_WIDTH  256
#define TEXTURE_HEIGHT 256
GLubyte texImage[TEXTURE_HEIGHT][TEXTURE_WIDTH][4];

struct Pixel{unsigned char b, g, r;};
struct PixelA{unsigned char b, g, r, a;};
struct Palette{unsigned char  r, g, b, a;};

// rbg}bṽwb_
struct BITMAPFILEHEADER{
  unsigned short Type;          //t@C^Cv:0x4D42
  unsigned long  Size;          //t@CTCY
  unsigned short Reserved1;     
  unsigned short Reserved2;
  unsigned long  OffBits;       //sNZf[^ւ̃ItZbg
};

struct BITMAPINFOHEADER{
    unsigned long  Size;         //BITMAPFILEHEADER̃TCY
    long           Width;        //BITMAPf[^̕
    long           Height;       //BITMAPf[^̍
    unsigned short Planes;       //J[v[
    unsigned short BitCount;     //F̐ 
    unsigned long  Compression;  //k`
    unsigned long  SizeImage;    //C[WTCY
    long           XPixPerMeter; //𑜓x
    long           YPixPerMeter; //𑜓x
    unsigned long  ClrUsed;      //pbg
    unsigned long  ClrImporant;  //J[CfbNX
};
struct RGBQUAD{
	unsigned char Blue; 
	unsigned char Green; 
	unsigned char Red; 
	unsigned char Reserved; 
};

struct BitmapData{
	BITMAPFILEHEADER bf;
	BITMAPINFOHEADER bi;
	struct Pixel* pixel;
	struct PixelA* pixelA;
} *bitmapdata;
int bpp;
int getByte(FILE *f) { return fgetc(f) & 0xFF; };
int get2Byte(FILE *f){ return fgetc(f) | fgetc(f) << 8;};
int get4Byte(FILE *f){ return fgetc(f) | fgetc(f) << 8 | fgetc(f) << 16 | fgetc(f) << 24; };

void readBitmap(const char *filename){
	FILE *fp = fopen( filename, "rb");
	if(!fp)cout << "t@CJƂł܂F" << filename << endl;

	//////////////////////////////////////////////////////////////////////
	// 54oCg̃wb_[擾
	//////////////////////////////////////////////////////////////////////
	if(get2Byte(fp) != 0x4D42){	//BM(B=42, M=4D)
		cout << "BMPt@Cł͂܂F" << filename << endl;
	}
	bitmapdata->bf.Size         = get4Byte(fp);
	bitmapdata->bf.Reserved1    = get2Byte(fp);
	bitmapdata->bf.Reserved2    = get2Byte(fp);
	bitmapdata->bf.OffBits      = get4Byte(fp);
	bitmapdata->bi.Size         = get4Byte(fp);
	bitmapdata->bi.Width        = get4Byte(fp);
	bitmapdata->bi.Height       = get4Byte(fp);
	bitmapdata->bi.Planes       = get2Byte(fp);
	bitmapdata->bi.BitCount     = get2Byte(fp);
	bitmapdata->bi.Compression  = get4Byte(fp);
	bitmapdata->bi.SizeImage    = get4Byte(fp);
	bitmapdata->bi.XPixPerMeter = get4Byte(fp);
	bitmapdata->bi.YPixPerMeter = get4Byte(fp);
	bitmapdata->bi.ClrUsed      = get4Byte(fp);
	bitmapdata->bi.ClrImporant  = get4Byte(fp);

	//////////////////////////////////////////////////////////////////////
	// wb_[ƂɃf[^̎擾
	//////////////////////////////////////////////////////////////////////
	if(bitmapdata->bi.BitCount == 8){//8bit mono or color
		bitmapdata->pixel = new Pixel[3 * bitmapdata->bi.Width * bitmapdata->bi.Height]; //SsNZi[郁̈擾
		int paletteSize = 1 << bitmapdata->bi.BitCount;
		Palette* plt = new Palette[paletteSize];
		for(int i = 0; i < paletteSize; i++){
			plt[i].b = fgetc(fp);
			plt[i].g = fgetc(fp);
			plt[i].r = fgetc(fp);
			plt[i].a = fgetc(fp);
		}

		for(int y = 0; y < bitmapdata->bi.Height; y++){
			for(int x = 0; x < bitmapdata->bi.Width; x++){
				int c = getByte(fp) ;
				Palette p = plt[c];
				bitmapdata->pixel[x + y * bitmapdata->bi.Width].b = (unsigned char)p.b;
				bitmapdata->pixel[x + y * bitmapdata->bi.Width].g = (unsigned char)p.g;
				bitmapdata->pixel[x + y * bitmapdata->bi.Width].r = (unsigned char)p.r;
			}
		}
	}	else if(bitmapdata->bi.BitCount == 24){//24bit color

		bitmapdata->pixel = new Pixel[3 * bitmapdata->bi.Width * bitmapdata->bi.Height];
		fread(bitmapdata->pixel, 1, 3*bitmapdata->bi.Width * bitmapdata->bi.Height, fp);

	} else {//32bit color
		bitmapdata->pixelA = new PixelA[4 * bitmapdata->bi.Width * bitmapdata->bi.Height];
		fread(bitmapdata->pixelA, 1, 4 * bitmapdata->bi.Width * bitmapdata->bi.Height, fp);
	}
	fclose(fp);
}
void makeTexture(int width, int height){
  for(int j = 0; j < height; j++){
		int jj = (int)((float)j * (float)bitmapdata->bi.Height / (float)height);
		for(int i = 0; i < width; i++){
      int ii = (int)((float)i * (float)bitmapdata->bi.Width / (float)width) ;
			if(bitmapdata->bi.BitCount <= 24){
				texImage[j][i][0] = (bitmapdata->pixel[ii+jj*bitmapdata->bi.Width]).r;
				texImage[j][i][1] = (bitmapdata->pixel[ii+jj*bitmapdata->bi.Width]).g;
				texImage[j][i][2] = (bitmapdata->pixel[ii+jj*bitmapdata->bi.Width]).b;
				texImage[j][i][3] = 255;
			}	else {
				texImage[j][i][0] = (bitmapdata->pixelA[ii+jj*bitmapdata->bi.Width]).r;
				texImage[j][i][1] = (bitmapdata->pixelA[ii+jj*bitmapdata->bi.Width]).g;
				texImage[j][i][2] = (bitmapdata->pixelA[ii+jj*bitmapdata->bi.Width]).b;
				texImage[j][i][3] = (bitmapdata->pixelA[ii+jj*bitmapdata->bi.Width]).a;
			}
    }
  }
}

//----------------------------------------------------
// VF[_RpC֘A
//----------------------------------------------------
GLuint shaderProgram;       //VF[_vO
/* _obt@IuWFNgID */
#define VERTEX  1
#define FRAGMENT  2

GLuint getShader(const char *file, int type)
{
	GLuint shader;
  if(type == VERTEX)        shader = glCreateShader(GL_VERTEX_SHADER);
  else if(type == FRAGMENT) shader = glCreateShader(GL_FRAGMENT_SHADER);

	ifstream ifs(file);
	istreambuf_iterator<char> vdataBegin(ifs);
	istreambuf_iterator<char> vdataEnd;
	string filedata(vdataBegin,vdataEnd);
	const char *vfile = filedata.c_str();

	glShaderSource(shader, 1, &vfile, NULL);	//\[XR[hVF[_IuWFNgɕϊ
	glCompileShader(shader);                  //RpC

	return shader;
}

void initShaders()
{
  //glew̏
  GLenum err = glewInit();
  if (err != GLEW_OK)
  {
	  printf("Error: %s\n", glewGetErrorString(err));
  }
	//VF[_[̓ǂݍ݂ƃRpC
  GLuint vertexShader   = getShader("../../Texture.vert", VERTEX);  //Phong or Gouraud
  GLuint fragmentShader = getShader("../../Texture.frag", FRAGMENT);

  shaderProgram = glCreateProgram();  // vOIuWFNg̍쐬 

  glAttachShader(shaderProgram, vertexShader);
  glAttachShader(shaderProgram, fragmentShader);

  glLinkProgram(shaderProgram);
}

GLuint vertexPositionID, vertexNormalID, vertexIndexID, textureCoodID, textureID;
void initBuffers(){

	//lp`̃obt@
	GLfloat vertices[][3] = { 
		{-2.5, -2.5, 0.0}, {2.5, -2.5, 0.0}, {2.5,  2.5, 0.0}, {-2.5,  2.5, 0.0}
	};
	GLfloat normals[][3] = {
		{0.0, 0.0, 1.0}, {0.0, 0.0, 1.0}, {0.0, 0.0, 1.0}, {0.0, 0.0, 1.0}
	};
	GLfloat textureCoords[][2] = {
		{0.0, 0.0},	{1.0, 0.0},	{1.0, 1.0}, {0.0, 1.0}
	};
	GLuint indices[6] = {
		0, 1, 2, 0, 2, 3
	};

  glGenBuffers(1, &vertexPositionID); 
	glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
  glBufferData(GL_ARRAY_BUFFER, sizeof (vertices), vertices , GL_STATIC_DRAW);

  glGenBuffers(1, &vertexNormalID); 
	glBindBuffer(GL_ARRAY_BUFFER, vertexNormalID);
  glBufferData(GL_ARRAY_BUFFER, sizeof (normals), normals , GL_STATIC_DRAW);

	glGenBuffers(1, &textureCoodID); 
	glBindBuffer(GL_ARRAY_BUFFER, textureCoodID);
  glBufferData(GL_ARRAY_BUFFER, sizeof(textureCoords), textureCoords, GL_STATIC_DRAW);

	glGenBuffers(1, &vertexIndexID);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(indices), indices, GL_STATIC_DRAW);
}

//----------------------------------------------------
// ݒ̊֐
//----------------------------------------------------
void initialize(void){

	glGenTextures(1, &textureID);             //eNX`ID̎擾
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);    //eNX`̌_ɂ
  glBindTexture(GL_TEXTURE_2D, textureID);

	bitmapdata = new BitmapData();               //rbg}bv\̂̐錾
	readBitmap("simyu-kun.bmp");                 //rbg}bvt@C̓ǂݍ
	makeTexture(TEXTURE_WIDTH, TEXTURE_HEIGHT);  //eNX`̍쐬
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);       //PoCgǂ݂
  //eNX`̎w 
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, TEXTURE_WIDTH, TEXTURE_HEIGHT, 0, GL_RGBA, GL_UNSIGNED_BYTE, texImage);
  //eNX`̌JԂ@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);//GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);//GL_CLAMP);
  //eNX`gEk@̎w 
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);//NEAREST);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);//NEAREST);
  glBindTexture(GL_TEXTURE_2D, 0);

	glClearColor(0.0, 0.0, 0.0, 1.0); //wiF
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glViewport( 0, 0, WindowWidth, WindowHeight );
	gluPerspective(30.0, (double)WindowWidth/(double)WindowHeight, 0.1, 1000.0); //e@̎̐gluPerspactive(th, w/h, near, far);
}
//--------------------------------------------------------
// AChɌĂяo֐
//--------------------------------------------------------
void idle(){
 glutPostRedisplay(); //glutDisplayFunc()Ps
}
//----------------------------------------------------
// `֐
//----------------------------------------------------
int step=0;
void draw(){
	step++;

	/////////////////////////////////////////////
	// ގ̎w
	/////////////////////////////////////////////
	GLfloat materialEmission[4] = {0.0,      0.0,      0.0,       1.0}; //F
	GLfloat materialAmbient[4]  = {0.1745,   0.01175,  0.01175,   1.0}; //ɑ΂F
	GLfloat materialDiffuse [4] = {0.61424,  0.04136,  0.04136,   1.0}; //gUɑ΂F
	GLfloat materialSpecular[4] = {0.727811, 0.626959, 0.626959,  1.0}; //ˌɑ΂F
	GLfloat materialShininess[1] = {76.8};                              //̋x
	glMaterialfv(GL_FRONT, GL_EMISSION,  materialEmission);  //F̎w
	glMaterialfv(GL_FRONT, GL_AMBIENT,   materialAmbient);   //ɑ΂F̎w
	glMaterialfv(GL_FRONT, GL_DIFFUSE,   materialDiffuse);   //gUɑ΂F̎w
	glMaterialfv(GL_FRONT, GL_SPECULAR,  materialSpecular);  //ˌɑ΂F̎w
	glMaterialfv(GL_FRONT, GL_SHININESS, materialShininess); //̋x̎w

	//texture unit  texture object ̊֘At
	//glActiveTexture(GL_TEXTURE0);
	glBindTexture(GL_TEXTURE_2D, textureID);
	//fragment shader̃jtH[ϐsamler̃CfbNX擾
	GLint samplerLoc = glGetUniformLocation(shaderProgram, "uSampler");
	glUniform1i(samplerLoc, 0);//GL_TEXTURE0Kp

	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glBindBuffer(GL_ARRAY_BUFFER, textureCoodID);
	glTexCoordPointer(2, GL_FLOAT, 0, 0);

	glPushMatrix();
		glTranslatef(0.0, 0.0, 0.0);     //sړ
		glRotatef(step , 1.0, 0.0, 0.0);  //]
		glEnableClientState(GL_VERTEX_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
		glVertexPointer(3, GL_FLOAT, 0, 0);

		glEnableClientState(GL_NORMAL_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexNormalID);
		glNormalPointer(GL_FLOAT, 0, 0);

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
		glDrawElements(GL_TRIANGLES, 6,	GL_UNSIGNED_INT, 0);
	glPopMatrix();
}

void display(void){
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //obt@̏
	glMatrixMode( GL_MODELVIEW ); //s񃂁[hfr[sɎw
	glLoadIdentity();             //Jgs̏
	/////////////////////////////////////////////
	// _̐ݒ
	/////////////////////////////////////////////
	gluLookAt(             // _̐ݒ
		   0.0, 0.0, 10.0,    // _̈ʒux,y,z;
		   0.0, 0.0, 0.0,    // E̒Sʒu̎QƓ_Wx,y,z
		   0.0, 1.0, 0.0);   // Ȅ̃xNgx,y,z

	/////////////////////////////////////////////
	// ̐ݒ
	/////////////////////////////////////////////
	GLfloat lightAmbient[4] = {0.1,0.1,0.1,1.0};   //F
	GLfloat lightDiffuse[4] = {1.0,1.0,1.0,1.0};   //gUF
	GLfloat lightSpecular[4] = {1.0,1.0,1.0,1.0};  //ˌF
	GLfloat lightPosition[4] = {0.0,0.0,1.0,0.0};  //ʒu
	glEnable(GL_LIGHTING);                             //̗L
	glEnable(GL_LIGHT0);                               //0̗L
	glLightfv( GL_LIGHT0, GL_AMBIENT,  lightAmbient);  //0̊F̎w
	glLightfv( GL_LIGHT0, GL_DIFFUSE,  lightDiffuse);  //0̊gUF̎w
	glLightfv( GL_LIGHT0, GL_SPECULAR, lightSpecular); //0̔ˌF̎w
	glLightfv( GL_LIGHT0, GL_POSITION, lightPosition); //0̌ʒu̎w

  glUseProgram(shaderProgram);

	draw();

	glUseProgram(0);

	glutSwapBuffers(); //glutInitDisplayMode(GLUT_DOUBLE)Ń_uobt@O𗘗p
}

//----------------------------------------------------
// C֐
//----------------------------------------------------
int main(int argc, char** argv){
	glutInit(&argc, argv);                                     //̏
	glutInitWindowPosition(WindowPositionX, WindowPositionY);  //EBhËʒu̎w
	glutInitWindowSize(WindowWidth, WindowHeight);             //EBhETCY̎w
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE); //fBXvC[h̎w
	glutCreateWindow(WindowTitle);                             //EBhE̍쐬
	glutDisplayFunc(display);                                  //`掞ɌĂяo֐w肷i֐Fdisplayj
	glutIdleFunc(idle);                                        //vOAChԎɌĂяo֐
  initShaders();
	initBuffers();
	initialize();                                              //ݒ̊֐Ăяo
	glutMainLoop();
 	glDeleteProgram(shaderProgram);
	return 0;
}
